---
apiVersion: v1
kind: Pod
metadata:
  labels:
    type: jupyter
    app: jupyter-test-service-id
    service-id: test-service-id
    pool-id: test-pool-id
    session-id: test-session-id
  name: jupyter-test-service-id
spec:
  imagePullSecrets:
    - name: testsecretname # gitlab deployment key stored in kubernetes secrets under this name
  initContainers:
    - name: service-init-container
      image: busybox
      command:
        - chown
        - "1000:100"
        - "/home/jovyan/work"
      volumeMounts:
        - name: working-directory
          mountPath: /home/jovyan/work
          subPath: test-pool-id
          readOnly: false
  containers:
    - args:
        - --ServerApp.root_dir=/home/jovyan/work
        - --ServerApp.allow_origin=*
        - --ServerApp.default_url=/lab
        - --IdentityProvider.token=1234abcd
        - --ServerApp.shutdown_no_activity_timeout=1210000
        - --TerminalManager.cull_inactive_timeout=1214000
        - --TerminalManager.cull_interval=3600
        - --MappingKernelManager.cull_connected=True
        - --MappingKernelManager.cull_idle_timeout=1210000
        - --MappingKernelManager.cull_interval=3600
        - --no-browser
        - --ServerApp.base_url=/swirrl/jupyter/test-service-id
        - --IdentityProvider.cookie_options={"SameSite":"Lax","Secure":False}
      command:
        - /data/scripts/start-notebook-pip.sh
      image: testtagname
      name: jupyter
      ports:
        - containerPort: 8888
      resources:
        requests:
          memory: 2700M
          cpu: 1000m
        limits:
          memory: 2700M
          cpu: 1000m
      env:
        - name: JUPYTER_ENABLE_LAB
          value: yes
      volumeMounts:
        - name: working-directory
          mountPath: /home/jovyan/work
          subPath: test-pool-id
        - name: data
          mountPath: /home/jovyan/work/data
          subPath: test-session-id
          readOnly: true
        - mountPath: /data/scripts
          name: startup-directory
        - mountPath: /opt/conda/bin/pip
          name: pip-wrapper
          subPath: pip
        - mountPath: /opt/conda/bin/swirrl-conda
          name: conda-wrapper
          subPath: swirrl-conda
        - mountPath: /data/env_vars
          name: env-var
      readinessProbe:
        tcpSocket:
          port: 8888
        initialDelaySeconds: 1
        periodSeconds: 1
  securityContext:
    fsGroup: 100
  restartPolicy: Never
  volumes:
    - name: data
      persistentVolumeClaim:
        claimName: data-directory-test-session-id
    - name: working-directory
      persistentVolumeClaim:
        claimName: working-directory-test-pool-id
    - configMap:
        defaultMode: 420
        items:
          - key: start-notebook-pip.sh
            mode: 492
            path: start-notebook-pip.sh
          - key: requirements.txt
            path: requirements.txt
          - key: wrapper_common.py
            path: wrapper_common.py
        name: substitute_name_by_tester
      name: startup-directory
    - configMap:
        defaultMode: 365
        name: jupyter-test-service-id-pip-wrapper
      name: pip-wrapper
    - configMap:
        defaultMode: 365
        name: jupyter-test-service-id-conda-wrapper
      name: conda-wrapper
    - configMap:
        defaultMode: 365
        name: jupyter-test-service-id-env-var
      name: env-var
